<template>
  <div>

    <!-- Table Container Card -->
    <b-card
      title="Lista de usuarios"
      class="mb-0"
    >

      <div class="m-2">

        <!-- Table Top -->
        <b-row>
          <!-- Per Page -->
          <b-col
            cols="12"
            md="6"
            class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
          >
          </b-col>

          <!-- Search -->
          <b-col
            cols="12"
            md="6"
          >
            <div class="d-flex align-items-center justify-content-end">
              <b-form-input
                v-model="searchQuery"
                class="d-inline-block mr-1"
                placeholder="Buscar..."
              />
              <b-button variant="primary" :to="{ name: 'apps-users-add'}">
                <span class="text-nowrap">Agregar Usuario
                </span>
              </b-button>
            </div>
          </b-col>
        </b-row>

      </div>

      <b-table
        class="position-relative"
        :items="users"
        responsive
        :fields="tableColumns"
        :filter="searchQuery"
        primary-key="id"
        show-empty
        empty-text="No se encontraron registros"
      >

        <template #cell(image)="data">
          <b-avatar
            v-if="data.item.image"
             class="mr-1" 

            size="lg"
             :src="baseURL+data.item.image"
          />
          <b-avatar
            v-else
             class="mr-1" 

            size="lg"
        
          />
        </template>
        <!-- Column: Actions -->
        <template #cell(actions)="data">
          <b-dropdown
            variant="link"
            no-caret
          >

            <template #button-content>
              <feather-icon
                icon="MoreVerticalIcon"
                size="16"
                class="align-middle text-body"
              />
            </template>
            <b-dropdown-item :to="{ name: 'apps-users-view', params: { id: data.item.id } }">
              <feather-icon icon="FileTextIcon" />
              <span class="align-middle ml-50">Detalles</span>
            </b-dropdown-item>

            <b-dropdown-item :to="{ name: 'apps-users-edit', params: { id: data.item.id } }">
              <feather-icon icon="EditIcon" />
              <span class="align-middle ml-50">Editar</span>
            </b-dropdown-item>

            <b-dropdown-item  >
              <feather-icon icon="TrashIcon" />
              <span @click="deleteUser(data.item.id)" class="align-middle ml-50">Eliminar</span>
            </b-dropdown-item>
          </b-dropdown>
        </template>

      </b-table>
      
    </b-card>
  </div>
</template>

<script>
import {
  BCard, BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BPagination,
} from 'bootstrap-vue'
import vSelect from 'vue-select'

export default {
  components: {

    BCard,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,

    vSelect,
  },
  data() {
    return {
      users:[],
      tableColumns:[
        { key: 'image'},
        { key: 'name', label: "Nombre", sortable: true },
        { key: 'last_name', label: "Apellidos", sortable: true },
        { key: 'job', label: "Puesto", sortable: true },
        { key: 'nickname', label: "Usuario", sortable: true },
        { key: 'actions' },
      ],
      searchQuery:'',
      baseURL:'http://quantumdaily-back.test/storage/',

    }
  },
  methods:{
    getUsers(){
      this.$http.get('usuarios').then(res=>{
        this.users = res.data.users
      }).catch(err=>{
        console.log(err);
      })
    },
    deleteUser(id){
      
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          let parametros = {id: id};
          this.$http.get("usuarios/delete", { params: parametros }).then((res) => {
            if(res.data.message === 'eliminado'){
              this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.getUsers()
            }else{
              this.$swal({
                title: 'Error!',
                text: ' No se pudo eliminar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
    }
  },
  mounted(){
    this.getUsers()
  },
}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
